#include "interface.h"

#include "HEPMC3event.h"
#include <cstring>

HEPMC3event *E;

void hepmc3eventinit(const char *filename, int lfilename)
{
  E = new HEPMC3event(strFtoC(filename, lfilename));
  E->Initialise();
}

void hepmc3eventwrite()
{
  E->Write();
}

void hepmc3eventclose()
{
  E->Close();
  delete E;
}

void hepmc3eventaddparticlein(int barcode, double px, double py, double pz, double e, int status)
{
  E->AddParticleIn(barcode, px,py,pz,e, status);
}

void hepmc3eventaddparticleout(int barcode, double px, double py, double pz, double e, int status)
{
  E->AddParticleOut(barcode, px,py,pz,e, status);
}

void hepmc3eventinitevent(double weight)
{
  E->InitEvent();
  E->SetWeight(weight);
}

void hepmc3eventattributeimpact(double value)
{
  E->Attribute_impact(value);
}

void hepmc3eventattributeeventtype(int value)
{
  E->Attribute_eventtype(value);
}

void hepmc3eventsetposition(double x, double y, double z)
{
  E->SetPosition(x,y,z);
}

std::string strFtoC(const char *str, int len)
{
    int tlen = 0;
    char tem;

    // Counts non-blank characters in a string str until a first blank character or the end of the string is met
    while (str[tlen] != ' ' && (tlen < len) && (tem = str[tlen++], tem));

    char *tstr = new char[tlen+1];
    std::strncpy(tstr, str, tlen);
    tstr[tlen] = '\0';
    std::string ret = std::string(tstr);
    delete [] tstr;
    return ret;
}
